#version 100

const float dx = 0.003922;
varying mediump vec2 aCoordinate;
varying mediump vec2 aFBOTextureCoord;
varying mediump vec2 aLiziTextureCoord;

uniform sampler2D fTextureFBO;//背景
uniform sampler2D fTextureLizi;//粒子特效
uniform sampler2D flogoTexture;//painting book
uniform sampler2D fgooglePlayTexture;//google play图标
uniform sampler2D fsearchPlayTexture;//搜索
uniform sampler2D fsearchTextTexture;//搜索文字

uniform int showLogo;
uniform float owh;//图片的宽高比 小于1
uniform float mLogoAlpha;

vec4 mixcolor(vec4 bottom, vec4 top, float topAlpha);
bool insetCoord(vec2 aCoordinate, float left, float right, float top, float bottom);
bool isEques(const vec4 rgba, const vec4 mPointColor);


void main() {
    vec4 rgba = texture2D(fTextureFBO, aFBOTextureCoord);
    gl_FragColor = rgba;

    vec4 newrgba = texture2D(fTextureLizi, aLiziTextureCoord);
    gl_FragColor = mixcolor(rgba, newrgba, 1.0);

    if (showLogo == 1){
        vec4 halfBlack = vec4(0, 0, 0, 1);
        gl_FragColor = mixcolor(rgba, halfBlack, 0.5);

        float baseStarY = 0.3;
        if (owh > 0.9){ //如果是正方形
            baseStarY = 0.4;
        }

        float logoWH = 2.77;//宽高比 新二次元
//        float logoWH = 3.33;//宽高比 老二次元
        float logoW = 0.75;
        float logoH = logoW/logoWH*owh;
        float logoLeftX = (1.0-logoW)*0.5;
        float logoRightX = logoLeftX+logoW;
        float logoTopY = baseStarY;
        float logoBottomY = logoTopY+logoH;

        if (insetCoord(aCoordinate, logoLeftX, logoRightX, logoTopY, logoBottomY)){
            vec4 logo = texture2D(flogoTexture, vec2((aCoordinate.x-logoLeftX)/logoW, (aCoordinate.y - logoTopY)/logoH));
            gl_FragColor = mixcolor(gl_FragColor, logo, 1.0);
        }


        float googleWH = 3.04;
        float googleW = 0.3;
        float googleH = googleW/googleWH*owh;
        float googleLeftX = (1.0-googleW)*0.5;
        float googleRightX = googleLeftX+googleW;
        float googleTopY = logoBottomY + 0.2*owh;
        float googleBottomY = googleTopY+googleH;

        if (insetCoord(aCoordinate, googleLeftX, googleRightX, googleTopY, googleBottomY)){
            vec4 google = texture2D(fgooglePlayTexture, vec2((aCoordinate.x-googleLeftX)/googleW, (aCoordinate.y - googleTopY)/googleH));
            gl_FragColor = mixcolor(gl_FragColor, google, 1.0);
        }


        float searchWH = 630.0/102.0;
        float searchW = 0.8;
        float searchH = searchW/searchWH*owh;
        float searchLeftX = (1.0-searchW)*0.5;
        float searchRightX = searchLeftX+searchW;
        float searchTopY = googleBottomY + 0.05*owh;
        float searchBottomY = searchTopY+searchH;

        if (insetCoord(aCoordinate, searchLeftX, searchRightX, searchTopY, searchBottomY)){
            vec4 search = texture2D(fsearchPlayTexture, vec2((aCoordinate.x-searchLeftX)/searchW, (aCoordinate.y - searchTopY)/searchH));
            gl_FragColor = mixcolor(gl_FragColor, search, 1.0);

            float textWH = 480.0/77.0;
            float textW = searchW*(482.0/630.0);
            float textH = textW/textWH*owh;
            float textLeftX =searchLeftX+ 30.0/630.0;
            float textRightX = textLeftX+textW;
            float textTopY = searchTopY + (searchH-textH)*0.5;
            float textBottomY = textTopY+textH;

            if (insetCoord(aCoordinate, textLeftX, textRightX, textTopY, textBottomY)){
                if (search.a > 0.0 && search.r > 0.8){
                    gl_FragColor = vec4(1, 1, 1, 1);
                }
                vec4 text = texture2D(fsearchTextTexture, vec2((aCoordinate.x-textLeftX)/textW, (aCoordinate.y - textTopY)/textH));
                if (isEques(search, vec4(1, 0, 0, 1))){
                    gl_FragColor = mixcolor(gl_FragColor, text, 1.0);
                }
            }
        }


    }
}

vec4 mixcolor(vec4 bottom, vec4 top, float topAlpha){
    return vec4(
    top.r+bottom.r*(1.0-top.a * topAlpha),
    top.g+bottom.g*(1.0-top.a * topAlpha),
    top.b+bottom.b*(1.0-top.a * topAlpha), 1.0);
}

bool insetCoord(vec2 aCoordinate, float left, float right, float top, float bottom){
    return aCoordinate.x > left &&
    aCoordinate.x < right &&
    aCoordinate.y > top &&
    aCoordinate.y < bottom;
}

bool isEques(const vec4 rgba, const vec4 mPointColor){
    float r = rgba.r - mPointColor.r;
    float g = rgba.g- mPointColor.g;
    float b = rgba.b- mPointColor.b;
    //float a = rgba.a- mPointColor.a;
    if (
    (r < dx && r> -dx) &&
    (g < dx && g> -dx) &&
    (b < dx && b> -dx)
    //&& (a < dx && a> -dx)
    ){
        return true;
    } else {
        return false;
    }
}